net.minecraft.world.chunk

## Class Chunk

- java.lang.Object
- - net.minecraft.world.chunk.Chunk

- Direct Known Subclasses:
    EmptyChunk

      public class Chunk
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `java.util.Map` | `chunkTileEntityMap`
    `java.util.List[]` | `entityLists`
    `boolean` | `field_150815_m`
    `boolean` | `hasEntities`
    `int[]` | `heightMap`
    `int` | `heightMapMinimum`
    `long` | `inhabitedTime`
    `boolean` | `isChunkLoaded`
    `boolean` | `isLightPopulated`
    `static boolean` | `isLit`
    `boolean` | `isModified`
    `boolean` | `isTerrainPopulated`
    `long` | `lastSaveTime`
    `int[]` | `precipitationHeightMap`
    `boolean` | `sendUpdates`
    `boolean[]` | `updateSkylightColumns`
    `World` | `worldObj`
    `int` | `xPosition`
    `int` | `zPosition`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Chunk(World p_i45447_1_, Block[] p_i45447_2_, byte[] p_i45447_3_, int p_i45447_4_, int p_i45447_5_)`
    `Chunk(World p_i45446_1_, Block[] p_i45446_2_, int p_i45446_3_, int p_i45446_4_)`
    `Chunk(World par1World, int par2, int par3)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addEntity(Entity par1Entity)`
    `void` | `addTileEntity(TileEntity p_150813_1_)`
    `boolean` | `canBlockSeeTheSky(int par1, int par2, int par3)`
    `void` | `enqueueRelightChecks()`
    `void` | `fillChunk(byte[] par1ArrayOfByte, int par2, int par3, boolean par4)`
    `boolean` | `func_150802_k()`
    `void` | `func_150804_b(boolean p_150804_1_)`
    `TileEntity` | `func_150806_e(int p_150806_1_, int p_150806_2_, int p_150806_3_)`
    `boolean` | `func_150807_a(int p_150807_1_, int p_150807_2_, int p_150807_3_, Block p_150807_4_, int p_150807_5_)`
    `int` | `func_150808_b(int p_150808_1_, int p_150808_2_, int p_150808_3_)`
    `void` | `func_150809_p()`
    `void` | `func_150812_a(int p_150812_1_, int p_150812_2_, int p_150812_3_, TileEntity p_150812_4_)`
    `void` | `generateHeightMap()`
    `void` | `generateSkylightMap()`
    `boolean` | `getAreLevelsEmpty(int par1, int par2)`
    `byte[]` | `getBiomeArray()`
    `BiomeGenBase` | `getBiomeGenForWorldCoords(int par1, int par2, WorldChunkManager par3WorldChunkManager)`
    `Block` | `getBlock(int p_150810_1_, int p_150810_2_, int p_150810_3_)`
    `int` | `getBlockLightValue(int par1, int par2, int par3, int par4)`
    `int` | `getBlockMetadata(int par1, int par2, int par3)`
    `ExtendedBlockStorage[]` | `getBlockStorageArray()`
    `ChunkCoordIntPair` | `getChunkCoordIntPair()`
    `void` | `getEntitiesOfTypeWithinAAAB(java.lang.Class par1Class, AxisAlignedBB par2AxisAlignedBB, java.util.List par3List, IEntitySelector par4IEntitySelector)`
    `void` | `getEntitiesWithinAABBForEntity(Entity par1Entity, AxisAlignedBB par2AxisAlignedBB, java.util.List par3List, IEntitySelector par4IEntitySelector)`
    `int` | `getHeightValue(int par1, int par2)`
    `int` | `getPrecipitationHeight(int par1, int par2)`
    `java.util.Random` | `getRandomWithSeed(long par1)`
    `int` | `getSavedLightValue(EnumSkyBlock par1EnumSkyBlock, int par2, int par3, int par4)`
    `TileEntity` | `getTileEntityUnsafe(int x, int y, int z)` Retrieves the tile entity, WITHOUT creating it.
    `int` | `getTopFilledSegment()`
    `boolean` | `isAtLocation(int par1, int par2)`
    `boolean` | `isEmpty()`
    `boolean` | `needsSaving(boolean par1)`
    `void` | `onChunkLoad()`
    `void` | `onChunkUnload()`
    `void` | `populateChunk(IChunkProvider par1IChunkProvider, IChunkProvider par2IChunkProvider, int par3, int par4)`
    `void` | `removeEntity(Entity par1Entity)`
    `void` | `removeEntityAtIndex(Entity par1Entity, int par2)`
    `void` | `removeInvalidTileEntity(int x, int y, int z)` Removes the tile entity at the specified position, only if it's marked as invalid.
    `void` | `removeTileEntity(int p_150805_1_, int p_150805_2_, int p_150805_3_)`
    `void` | `resetRelightChecks()`
    `void` | `setBiomeArray(byte[] par1ArrayOfByte)`
    `boolean` | `setBlockMetadata(int par1, int par2, int par3, int par4)`
    `void` | `setChunkModified()`
    `void` | `setLightValue(EnumSkyBlock par1EnumSkyBlock, int par2, int par3, int par4, int par5)`
    `void` | `setStorageArrays(ExtendedBlockStorage[] par1ArrayOfExtendedBlockStorage)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### isLit

          public static boolean isLit

    - #### precipitationHeightMap

          public int[] precipitationHeightMap

    - #### updateSkylightColumns

          public boolean[] updateSkylightColumns

    - #### isChunkLoaded

          public boolean isChunkLoaded

    - #### worldObj

          public World worldObj

    - #### heightMap

          public int[] heightMap

    - #### xPosition

          public final int xPosition

    - #### zPosition

          public final int zPosition

    - #### chunkTileEntityMap

          public java.util.Map chunkTileEntityMap

    - #### entityLists

          public java.util.List[] entityLists

    - #### isTerrainPopulated

          public boolean isTerrainPopulated

    - #### isLightPopulated

          public boolean isLightPopulated

    - #### field_150815_m

          public boolean field_150815_m

    - #### isModified

          public boolean isModified

    - #### hasEntities

          public boolean hasEntities

    - #### lastSaveTime

          public long lastSaveTime

    - #### sendUpdates

          public boolean sendUpdates

    - #### heightMapMinimum

          public int heightMapMinimum

    - #### inhabitedTime

          public long inhabitedTime

  - ### Constructor Detail

    - #### Chunk

          public Chunk(World par1World,
               int par2,
               int par3)

    - #### Chunk

          public Chunk(World p_i45446_1_,
               Block[] p_i45446_2_,
               int p_i45446_3_,
               int p_i45446_4_)

    - #### Chunk

          public Chunk(World p_i45447_1_,
               Block[] p_i45447_2_,
               byte[] p_i45447_3_,
               int p_i45447_4_,
               int p_i45447_5_)

  - ### Method Detail

    - #### isAtLocation

          public boolean isAtLocation(int par1,
                             int par2)

    - #### getHeightValue

          public int getHeightValue(int par1,
                           int par2)

    - #### getTopFilledSegment

          public int getTopFilledSegment()

    - #### getBlockStorageArray

          public ExtendedBlockStorage[] getBlockStorageArray()

    - #### generateHeightMap

          public void generateHeightMap()

    - #### generateSkylightMap

          public void generateSkylightMap()

    - #### func_150808_b

          public int func_150808_b(int p_150808_1_,
                          int p_150808_2_,
                          int p_150808_3_)

    - #### getBlock

          public Block getBlock(int p_150810_1_,
                       int p_150810_2_,
                       int p_150810_3_)

    - #### getBlockMetadata

          public int getBlockMetadata(int par1,
                             int par2,
                             int par3)

    - #### func_150807_a

          public boolean func_150807_a(int p_150807_1_,
                              int p_150807_2_,
                              int p_150807_3_,
                              Block p_150807_4_,
                              int p_150807_5_)

    - #### setBlockMetadata

          public boolean setBlockMetadata(int par1,
                                 int par2,
                                 int par3,
                                 int par4)

    - #### getSavedLightValue

          public int getSavedLightValue(EnumSkyBlock par1EnumSkyBlock,
                               int par2,
                               int par3,
                               int par4)

    - #### setLightValue

          public void setLightValue(EnumSkyBlock par1EnumSkyBlock,
                           int par2,
                           int par3,
                           int par4,
                           int par5)

    - #### getBlockLightValue

          public int getBlockLightValue(int par1,
                               int par2,
                               int par3,
                               int par4)

    - #### addEntity

          public void addEntity(Entity par1Entity)

    - #### removeEntity

          public void removeEntity(Entity par1Entity)

    - #### removeEntityAtIndex

          public void removeEntityAtIndex(Entity par1Entity,
                                 int par2)

    - #### canBlockSeeTheSky

          public boolean canBlockSeeTheSky(int par1,
                                  int par2,
                                  int par3)

    - #### func_150806_e

          public TileEntity func_150806_e(int p_150806_1_,
                                 int p_150806_2_,
                                 int p_150806_3_)

    - #### addTileEntity

          public void addTileEntity(TileEntity p_150813_1_)

    - #### func_150812_a

          public void func_150812_a(int p_150812_1_,
                           int p_150812_2_,
                           int p_150812_3_,
                           TileEntity p_150812_4_)

    - #### removeTileEntity

          public void removeTileEntity(int p_150805_1_,
                              int p_150805_2_,
                              int p_150805_3_)

    - #### onChunkLoad

          public void onChunkLoad()

    - #### onChunkUnload

          public void onChunkUnload()

    - #### setChunkModified

          public void setChunkModified()

    - #### getEntitiesWithinAABBForEntity

          public void getEntitiesWithinAABBForEntity(Entity par1Entity,
                                            AxisAlignedBB par2AxisAlignedBB,
                                            java.util.List par3List,
                                            IEntitySelector par4IEntitySelector)

    - #### getEntitiesOfTypeWithinAAAB

          public void getEntitiesOfTypeWithinAAAB(java.lang.Class par1Class,
                                         AxisAlignedBB par2AxisAlignedBB,
                                         java.util.List par3List,
                                         IEntitySelector par4IEntitySelector)

    - #### needsSaving

          public boolean needsSaving(boolean par1)

    - #### getRandomWithSeed

          public java.util.Random getRandomWithSeed(long par1)

    - #### isEmpty

          public boolean isEmpty()

    - #### populateChunk

          public void populateChunk(IChunkProvider par1IChunkProvider,
                           IChunkProvider par2IChunkProvider,
                           int par3,
                           int par4)

    - #### getPrecipitationHeight

          public int getPrecipitationHeight(int par1,
                                   int par2)

    - #### func_150804_b

          public void func_150804_b(boolean p_150804_1_)

    - #### func_150802_k

          public boolean func_150802_k()

    - #### getChunkCoordIntPair

          public ChunkCoordIntPair getChunkCoordIntPair()

    - #### getAreLevelsEmpty

          public boolean getAreLevelsEmpty(int par1,
                                  int par2)

    - #### setStorageArrays

          public void setStorageArrays(ExtendedBlockStorage[] par1ArrayOfExtendedBlockStorage)

    - #### fillChunk

          public void fillChunk(byte[] par1ArrayOfByte,
                       int par2,
                       int par3,
                       boolean par4)

    - #### getBiomeGenForWorldCoords

          public BiomeGenBase getBiomeGenForWorldCoords(int par1,
                                               int par2,
                                               WorldChunkManager par3WorldChunkManager)

    - #### getBiomeArray

          public byte[] getBiomeArray()

    - #### setBiomeArray

          public void setBiomeArray(byte[] par1ArrayOfByte)

    - #### resetRelightChecks

          public void resetRelightChecks()

    - #### enqueueRelightChecks

          public void enqueueRelightChecks()

    - #### func_150809_p

          public void func_150809_p()

    - #### getTileEntityUnsafe

          public TileEntity getTileEntityUnsafe(int x,
                                       int y,
                                       int z)

      Retrieves the tile entity, WITHOUT creating it. Good for checking if it exists.
      Parameters:
        `x` -
        `y` -
        `z` -
      Returns:
        The tile entity at the specified location, if it exists and is valid.

    - #### removeInvalidTileEntity

          public void removeInvalidTileEntity(int x,
                                     int y,
                                     int z)

      Removes the tile entity at the specified position, only if it's marked as invalid.
      Parameters:
        `x` -
        `y` -
        `z` -